﻿using UnityEngine;
using System.Collections;

public class FireScript : MonoBehaviour
{

  PlayerHealth parentHealth;

  public float constantDamagepoints = 0.1f;

  public float burningTime = 10f;

  private Vector3 startScale; //fixes a bug: scale of fire was 0 when attached to the player.

  private Vector2 spawnPosition;
  public float respawnTime = 5.0f;

  public float relayDelay = 0.25f;
  private bool canRelay = true;
  private AudioSource pickupAudio;

  void Start()
  {
    startScale = transform.localScale;
    spawnPosition = transform.position;
    pickupAudio = GetComponent<AudioSource>();
  }

  // Update is called once per frame
  void Update()
  {
    if (parentHealth)
    {
      parentHealth.changeHealthBy(-constantDamagepoints * Time.deltaTime);
    }
  }

  void OnTriggerEnter2D(Collider2D other)
  {
    if (canRelay && other.tag == "Player")
    {
      Invoke("stopBurning", burningTime);
      parentHealth = other.GetComponent<PlayerHealth>();
      transform.position = other.transform.position + new Vector3(0f, 0.2f, 0f); //hier schon position setzen
      transform.parent = other.transform;
      transform.localScale = startScale;
      canRelay = false;
      Invoke("enableRelay", relayDelay);
      if (pickupAudio) pickupAudio.Play();
    }
  }

  void enableRelay()
  {
    canRelay = true;
  }

  void stopBurning()
  {
    CancelInvoke("stopBurning");
    parentHealth = null;
    transform.parent = null;
    transform.position = new Vector2(100, 100);
    Invoke("Activate", respawnTime);
  }

  void Activate()
  {
    transform.position = spawnPosition;
  }
}
