﻿using UnityEngine;
using System.Collections;

public class ShieldScript : MonoBehaviour
{

  PlayerHealth parentHealth;

  public float shieldingTime = 10;

  public float respawnTime = 5.0f;

  // used to store the position while the trap is deactivated
  private Vector2 spawnPosition;

  public float relayDelay = 0.25f;
  private bool canRelay = true;
  public AudioSource pickupAudio;

  // Use this for initialization
  void Start()
  {
    spawnPosition = transform.position;
    pickupAudio = GetComponent<AudioSource>();
  }

  void OnTriggerEnter2D(Collider2D other)
  {
    PlayerHealth oldHealth = parentHealth;
    if (canRelay && other.tag == "Player")
    {
      Invoke("stopShielding", shieldingTime);
      parentHealth = other.GetComponent<PlayerHealth>();
      transform.position = other.transform.position; //hier schon position setzen
      transform.parent = other.transform;
      Debug.Log("Set shield from shield");
      parentHealth.setShield(true);
      canRelay = false;
      Invoke("enableRelay", relayDelay);
      if (pickupAudio) pickupAudio.Play();
    }
    if (oldHealth != null && oldHealth != parentHealth) oldHealth.setShield(false);

  }

  void enableRelay()
  {
    canRelay = true;
  }

  void stopShielding()
  {
    CancelInvoke("stopShielding");
    if (parentHealth != null) parentHealth.setShield(false);
    parentHealth = null;
    transform.parent = null;
    transform.position = new Vector2(100, 100);
    Invoke("Activate", respawnTime);
  }

  void Activate()
  {
    transform.position = spawnPosition;
  }
}
